      program new_cumkehr_algorithm
C *******************************************************************
C ***** THIS IS PGM.MK2V4.NEWCUMK ********************* 22.NOV.1991**
c ***** *****REVISED ***** 20.NOV.1994 ******************************
c ***** REVISED 12.APR.1995 RE ERROR IN SEPSIN(MEQ)>>VERSION MK2V4A *
c ***** Minor mods to input/output 10 Nov 96  ***********************
C ***** THIS IS THE MAIN PROGRAM FOR THE NEW C-UMKEHR INVERSION *****
C ***** ALGORITHM USING BASS-PAUR OZONE ABSORPTION COEFFICIENTS *****
C ***** THE ALGORITHM FOLLOWS EQUATION 100 OF RODGER'S 1976 REVIEW **
C ***** IN REV. GEOPHYS. & SPACE PHYS., 14(4), PP. 609-624. *********
C *******************************************************************
      DIMENSION PUF(61),DPUF(61),PUFL(61),SLS(61),HH(61),
     1 DHH(61),DLIDX(61,2),SEPS(16),DLIDLX(61,12),SXN(61),
     2 DXN(61),TT(61),DTT(61),TDX(16),TDXN(16),
     3 PUL(16),TDXP(16),                                                TEMP****
     3 COVF(13,13),SXINV(13,13),VARN(12),THENOT(12),TENSTY(2),VALN(12), 00000050
     4 AKTSE(12,13),AKTSEK(13,13),FVEC(13),SERX(13),DY(12),DYMKDX(12),  00000060
     5 ALFA(2),BETA(2),CQMSP(12,43),CQMSS(12,9),
     6 AK(12,13),VNOB(12),FSOL(13,9),RES(12),FORSHD(12),CHPP(61,12)
     7 ,ID(7),SEPSIN(12),ALFT(61,2),ACOFT(2),DELT(61),
     9 ACOFTS(2),ALFBAR(2),TOTREF(5),REFCOR(12,5)
      DIMENSION P3BAR(13),P3DEV(13),ERROR(13),VARED(13)                 00000110
      character*1 jsx
      integer*2 skipref,juzsea
      character*11 result
      character*30 ft4,ft6,ft12,ft14,ft10
      CHARACTER*72 HEAD                                                 TEMP****
      character*51 head2
      CHARACTER*18 STATN                                                TEMP****
      INTEGER IL(13)                                                    TEMP****
      COMMON /BBBB/ SLANT(12,1891),CQMS(12,86)
      REAL*8 DET                                                        00000140
C *******************************************************************
C ***** INITIALIZATION SEGMENT **************************************
C *******************************************************************
      DATA HEAD/72H*****MARK 2 VERSION 4A NEW STANDARD C-UMKEHR USING BATEMP****
     1SS COEFFICIENTS****/                                              TEMP****
      data head2/51H     Date: 12 Apr 95  ***  Minor mods: 10 Nov 96 **/
      DATA ALFA/2.1960,0.1151/
      DATA ACOFT/5.6383E-3,6.8329E-4/                                   00000160
      DATA ACOFTS/2.9501E-5,3.8094E-6/                                  00000170
      DATA BETA/1.0362,0.7845/                                          00000180
      DATA IL/4,5,6,7,8,9,10,11,12,13,14,15,16/                         00000190
      DATA THENOT/60.,65.,70.,74.,77.,80.,83.,85.,86.5,88.,89.,90./     00000220
c **** open input and output data files *****
      print4002, head
      print4003, head2
      print*
      print*,'   enter name of input file from decode:  '
      read*,ft10
      open (unit=10,file=ft10,status='old')
      open (unit=11,file='phprofil.dat',status='old')
      open (unit=13,file='refractn.dat',status='old')
      open (unit=9,file='fstguess.dat',status='old')
      open (unit=8,file='mulscat.dat',status='old')
      print*,'     input file name for unit 6 output:   '
      read*,ft6
      open (unit=6,file=ft6,status='new')
      print*,'     input name of Sx matrix file:   '
      read*,ft12
      open (unit=12,file=ft12,status='old')
      print*,'     input name of nucumout file:   '
      read*,ft4
      open (unit=4,file=ft4,status='new')
      print*,'     input name of nucprint file:   '
      read*,ft14
      open (unit=14,file=ft14,status='new')
      write (6,4002) head
      write (6,4003) head2
      write (6,9011) ft10
 9011 format (' decoded input file for this run:   ',a30)
 9002 format (' archive output file for this run:  ',a30)
 9004 format (' unit 6 output file for this run:   ',a30)
 9003 format (' detail output file for this run:   ',a30)
 9005 format (' total ozone correction factor =',f7.4)
 9014 format (' Sx matrix code = ',a1)
      write (6,9002) ft4
      write (6,9003) ft14
      write (6,9004) ft6
c **** end of open statements and printing start time *****
      R=6371.                                                           00000230
      PI=ACOS(-1.)                                                      00000240
      CNVRT=PI/180.                                                     00000250
      WTX=100.                                                          00000260
      ITMAX=5                                                           00000270
      juzout=1
      juzdsk=1
      print*,'  enter total ozone correction factor:  '
      read*,omfac
      print*,'  enter Sx matrix code:  '
      read*,jsx
      write (6,9005) omfac
      write (6,9014) jsx
      skipref=0
      juzsea=1      
      jc=4
c ****
      call time (result)
      print*,'     start time:   ',result
      write (6,8888) result
 8888 format (' start time: ',a11)
c ****
      JUZPR=0
      JUZFGR=0
      JUTMPR=0
      CALL LAYER (PUL,PUFL,PUF,DPUF,DPSL,NC,NCP1,JC)                    00000300
C ***** READ PRIOR INFORMATION MATRICES                                 00000310
C ***** PROFILE COVARIANCE MATRIX                                       00000320
      READ (12,5200) ((COVF(I,J),I=1,13),J=1,13)                        00000330
      WRITE (6,9040) ft12
 9040 FORMAT (' PROFILE COVARIANCE MATRIX USED IN THIS RUN:',2x,a30/)
      CALL MATINV (13,COVF,SXINV,DET)                                   00000370
C ***** MEASUREMENT VARIANCE VECTOR                                     00000380
      READ (12,5300) (VARN(K),K=1,12)
C ***** TOTAL CONSERVATION VARIANCE                                     00000400
      READ (12,5400) VARX
      MM=0                                                              00000420
      DA=0.                                                             00000430
      DO 150 K=1,12                                                     00000440
      IF (K.GT.1) GO TO 145                                             00000450
      DA=VARN(K)                                                        00000460
      GO TO 150                                                         00000470
  145 MM=MM+1                                                           00000480
      SEPS(MM)=VARN( K)+DA                                              00000490
      SEPSIN(MM)=1.0/SEPS(MM)                                           00000500
  150 CONTINUE                                                          00000510
      MM=MM+1                                                           00000520
      SEPS(MM)=VARX*(WTX**2)                                            00000530
      SEPSIN(MM)=1./SEPS(MM)                                            00000540
C ****** READ MULTIPLE SCATTERING CORRECTIONS *********
      READ (8,5500) ((CQMS(I,J),I=1,12),J=1,86)
 5500 FORMAT (8X,12F6.1)                                                00000640
C ****** READ REFRACTION CORRECTIONS *******************
      READ (13,5501) (TOTREF(I),(REFCOR(J,I),J=12,1,-1),I=1,5)
 5501 FORMAT (6X,F2.0,12F6.2)
      DO 160 I=1,5
  160 TOTREF(I)=0.01*TOTREF(I)
C ****************************************************
      CALL STNDRD (PUFL,DPUF,HH,DHH,CHPN,SQCHP,NCP1,JC)
      DD=R+R*HH(1)                                                      00000690
      DH=R*(HH(1)-HH(9))                                                00000700
      SCALX=DH/1.282                                                    00000710
      CHX=0.5*DD/SCALX                                                  00000720
      CHXN=SQRT(PI*CHX)                                                 00000730
      SQCHX=SQRT(CHX)                                                   00000740
      CALL SLANTS (NCP1,THENOT,SQCHP,CHPN,SQCHX,CHXN,HH,DHH,CHPP)       00000750
C *******************************************************************
C *****END OF INITIALIZATION SEGMENT ********************************
C ***** BEGIN PROCESSING DATA FOR FIRST UMKEHR STATION **************
C ***** INITIALIZATION FOR STATION BATCH OF UMKEHR DATA *************
C *******************************************************************
  190 READ (10,5010) ISN,STATN,ALAT,PNOT,HGT                            TEMP****
 5010 FORMAT (I4,1X,A18,1X,F8.2,2F6.0)                                  TEMP****
      PNOT=PNOT/1013.25                                                 TEMP****
      nc=15*jc
      ncp1=nc+1
      IB=NCP1-JC
      DO 200 I=IB,NCP1
      IF (PNOT.LE.PUF(I)) THEN
         PSQ=SQRT(PUF(I)*PUF(I-1))
         NCP1=I
         IF (PNOT.LT.PSQ) NCP1=I-1
         NC=NCP1-1
      ENDIF
  200 CONTINUE
      PUL(16)=PUFL(NCP1)                                                00000830
C *** DETERMINE ILAT AND FLAT FOR STD PROFILE CALCULATION ***********
      FLAT=(105.-ALAT)/30.                                              TEMP****
      IF (FLAT.LE.1.0) FLAT=1.0001                                      TEMP****
      IF (FLAT.GE.6.0) FLAT=5.9999
      ILAT=INT(FLAT)                                                    TEMP****
      FLAT=FLAT-FLOAT(ILAT)                                             TEMP****
      IF (ILAT.EQ.3 .AND. ALAT.LE.0.) THEN
         ILAT=4
         FLAT=0.
      ENDIF
C *** INTERPOLATE CQMS FOR THIS STATION'S PNOT **********************
      FP1=(PNOT-.8112)/0.1888
      FP2=(1.0-PNOT)/0.1888
      IF (PNOT.LE.0.75) THEN
         FP1=0.
         FP2=1.
      ENDIF
      DO 210 L=1,43
      LP=L+43
      DO 210 I=1,12
  210 CQMSP(I,L)=FP1*CQMS(I,L)+FP2*CQMS(I,LP)
      IF (ILAT.EQ.1) THEN
         L1=1
         L2=16
      ELSE IF (ILAT.EQ.2) THEN
         L1=9
         L2=21
      ELSE IF (ILAT.EQ.3) THEN
         L1=17
         L2=21
      ELSE IF (ILAT.EQ.4) THEN
         L1=22
         L2=34
      ELSE
         L1=27
         L2=43
      ENDIF
C ***INTERPOLATE CQMS TABLE FOR THIS STATION'S LATITUDE *************
      IF (ILAT.EQ.1) THEN
         DO 211 I=1,12
         DO 211 L=1,8
         LP=L+8
  211    CQMSS(I,L)=(1.-FLAT)*CQMSP(I,L)+FLAT*CQMSP(I,LP)
         J1MAX=7
      ELSE IF (ILAT.EQ.2) THEN
         DO 213 I=1,12
         DO 212 L=1,5
         L1=L+8
         L2=L+16
  212    CQMSS(I,L)=(1.-FLAT)*CQMSP(I,L1)+FLAT*CQMSP(I,L2)
         DO 213 L=6,8
         L1=L+8
  213    CQMSS(I,L)=CQMSP(I,L1)
         J1MAX=7
      ELSE IF (ILAT.EQ.3) THEN
         DO 214 I=1,12
         DO 214 L=1,5
         L1=L+16
  214    CQMSS(I,L)=CQMSP(I,L1)
         J1MAX=4
      ELSE IF (ILAT.EQ.4) THEN
         DO 216 I=1,12
         DO 215 L=1,5
         L1=L+21
         L2=L1+5
  215    CQMSS(I,L)=(1.-FLAT)*CQMSP(I,L1)+FLAT*CQMSP(I,L2)
         DO 216 L=6,8
         L2=L+26
  216    CQMSS(I,L)=CQMSP(I,L2)
         J1MAX=7
      ELSE
         DO 217 I=1,12
         CQMSS(I,1)=CQMSP(I,35)
         DO 217 L=2,9
         L1=L+25
         L2=L+34
  217    CQMSS(I,L)=(1.-FLAT)*CQMSP(I,L1)+FLAT*CQMSP(I,L2)
         J1MAX=8
      ENDIF
C *** CONTINUE INITIALIZATION FOR THIS STATION BATCH ****************
      NITER=0
      ISOL=0                                                            00000840
      NSOL=0                                                            00000850
      RESBAR=0.                                                         00000860
      RESDEV=0.                                                         00000870
      OMOBAR=0.                                                         00000880
      OMODEV=0.                                                         00000890
      OMSBAR=0.                                                         00000900
      OMSDEV=0.                                                         00000910
      DO 218 I=1,13
      P3BAR(I)=0.                                                       00000930
      P3DEV(I)=0.                                                       00000940
      ERROR(I)=0.                                                       00000950
  218 VARED(I)=0.                                                       00000960
C *******************************************************************
C ***** END OF INITIALIZATION FOR THIS STATION **********************
C ***** READ STANDARD C-UMKEHR DATA FOR THIS STATION ****************
C *******************************************************************
  220 READ (10,5600,END=900) (ID(I),I=3,6),LAM,KB,KE,ID(7),             TEMP****
     1 IOMEGA,(VNOB(K),K=1,12),ISTN                                     00000980
 5600 FORMAT (3I2,A1,I1,2I2,A2,I4,2F4.1,10F5.1,I3)                      TEMP****
C ***** CHECK FOR END OF BATCH FOR THIS STATION *********************
      IF (ID(3).EQ.99) GO TO 900                                        TEMP****
      IF (ISTN.NE.ISN) THEN                                             TEMP****
         WRITE (6,9001) ISTN,ISN                                        TEMP****
 9001 FORMAT (' UMKEHR STATION NO.',I4,'DIFFERS FROM THAT ON BATCH HEADETEMP****
     1R CARD.',I4,'RUN TERMINATED.')                                    TEMP****
         STOP                                                           TEMP****
      ENDIF                                                             TEMP****
C ***** CHECK FOR SOLAR ZENITH ANGLE RANGE FOR THIS UMKEHR **********
      IF (KB.GT.3 .OR. KE.LT.11) THEN
         WRITE (6,7777) (ID(I),I=3,6),KB,KE
         GO TO 220
      ENDIF
 7777 FORMAT (' THIS UMKEHR OUTSIDE ZENITH ANGLE LIMITS DATE',3I3,5X,
     1 2HT=,A1,3X, 'KB=',I3,3X,'KE=',I3)
      OMOBS=0.001*FLOAT(IOMEGA)                                         00001090
      OMOBS=OMOBS*OMFAC
      OMFG=OMOBS                                                        TEMP****
      ISOL=ISOL+1                                                       TEMP****
      call time(result)
      print*,'   isol= ',isol,'    time=   ',result
      IF (MOD(ISOL,6).EQ.1 .AND. JUZDSK.EQ.0) THEN
         WRITE (6,6000) HEAD
         WRITE (6,6001) ALAT,PNOT,HGT
         WRITE (6,9000)
      ENDIF
 6001 FORMAT (1H ,19X,'LATITUDE=',F8.2,5X,'SFC PRESSURE=',F6.3,' ATM',  TEMP****
     15X,'STN HEIGHT=',F6.0,' M',5X,'STD TEMP PROFILE')
      IF (JUZDSK.EQ.1 .AND. MOD(ISOL,15).EQ.1) THEN
         WRITE (14,4000) HEAD
         WRITE (14,4001) ALAT,PNOT,HGT
      ENDIF
      IF (JUZDSK.EQ.0) THEN
         WRITE (6,6100) STATN,(ID(I),I=3,5),LAM,ID(6),KB,KE,ID(7),OMOBS
      ELSE
         WRITE (14,4011)STATN,(ID(I),I=3,5),LAM,ID(6),KB,KE,ID(7),OMOBS
      ENDIF
C ***** CALCULATION OF FIRST GUESS PROFILE **************************
      JUMP=1
  221 CONTINUE
      CALL SASCO3 (ID,ILAT,PNOT,OMOBS,TDX,juzsea)
      IF (ILAT.EQ.4 .AND. ALAT.GE.-15.) GO TO 224
      IF (ILAT.NE.3) THEN
         ILATP=ILAT+1
         XFLAT=FLAT
         CALL SASCO3 (ID,ILATP,PNOT,OMOBS,TDXP,juzsea)
         IF (ILAT.EQ.2 .AND. OMOBS.GT.0.4) XFLAT=0.
         IF (ILAT.EQ.4 .AND. OMOBS.GT.0.4) XFLAT=1.0
         IF (ILAT.EQ.5 .AND. OMOBS.LT.0.2) XFLAT=1.0
         DO 222 I=1,16
  222    TDX(I)=(1.-XFLAT)*TDX(I)+XFLAT*TDXP(I)
      ENDIF
  224 CONTINUE
      CALL EXPAND (PUL,TDX,NCP1,PUFL,SXN,DXN)
      DO 247 I=2,NCP1
      DELT(I)=34.16316*R*DHH(I)/(PUFL(I)-PUFL(I-1))-273.15
      TFAC=1.0112 - 0.6903 / (87.3 - DELT(I))
      DO 246 L=1,2
      ALFT(I,L)=(ALFA(L)+DELT(I)*(ACOFT(L)+DELT(I)*ACOFTS(L)))*TFAC
      IF (I.GT.2) GO TO 246
      ALFT(1,L)=ALFT(2,L)
  246 CONTINUE
  247 CONTINUE
      IF (JUTMPR.EQ.1 .AND. JUMP.EQ.0) WRITE (6,8001) (I,DELT(I),
     1 ALFT(I,1),ALFT(I,2),I=2,NCP1)
 8001 FORMAT (4(I7,F7.1,2F9.5))
      DO 2474 L=1,2
      SUM=0.
      SUMX=0.
      DO 2472 I=1,NCP1
      SUM=SUM+ALFT(I,L)*DXN(I)
      SUMX=SUMX+DXN(I)
 2472 CONTINUE
      ALFBAR(L)=SUM/SUMX
 2474 CONTINUE
      ALFAC=ALFBAR(1)-ALFBAR(2)
      OMOBS=OMFG/ALFAC*1.918
      IF (ABS(OMOBS-OMFG).GT.0.0001 .AND. JUMP.EQ.1) THEN
         JUMP=0
         GO TO 221
      ENDIF
      IF (JUZDSK.EQ.0)
     1WRITE (6,8003) OMOBS,ALFAC,(ALFBAR(L),L=1,2)
 8003 FORMAT (11H NEW TOTOZ=,3PF7.1,5X,10HNEW ALFAC=,0PF7.4,
     1 3X,9HALFABARS=,2F7.4)
      OMFG=OMOBS                                                        TEMP****
      OMSOL=OMFG                                                        TEMP****
C ***** APPLY MULTIPLE SCATTERING CORRECTIONS TO OBSERVED N-VALUES **
      IF (ILAT.LT.5) THEN
         AAAA=(OMOBS-.150)/.05
      ELSE
         AAAA=(OMOBS-.100)/.05
      ENDIF
      J1=INT(AAAA)                                                      00001140
      IF (J1.LT.1) J1=1                                                 00001150
      IF (J1.GT.J1MAX) J1=J1MAX
      J2=J1+1                                                           00001170
      FFF1=AAAA-FLOAT(J1)                                               00001180
      FFF2=FLOAT(J2)-AAAA                                               00001190
      DO 10 K=KB,KE                                                     00001200
   10 VNOB(K)=VNOB(K)-(FFF2*CQMSS(K,J1)+FFF1*CQMSS(K,J2))
C ****** APPLY REFRACTION CORRECTIONS TO OBSERVED N-VALUES***********
      if (skipref.eq.1) go to 17
      DO 16 I=1,4
      IP=I+1
      OMCHEK=OMOBS
      IF (OMOBS.GT.0.55) OMCHEK=0.55
      IF (OMCHEK.GT.TOTREF(I) .AND. OMCHEK.LE.TOTREF(IP)) THEN
         GGG1=(TOTREF(IP)-OMOBS)/(TOTREF(IP)-TOTREF(I))
         GGG2=1.0-GGG1
         DO 15 K=1,12
   15    VNOB(K)=VNOB(K)-GGG1*REFCOR(K,I)-GGG2*REFCOR(K,IP)
      ENDIF
   16 CONTINUE
   17 continue
C *******************************************************************
      MEQ=KE-KB+1                                                       00001290
      MEQM=MEQ-1                                                        00001300
      KBP=KB+1                                                          00001310
      kcqn=12-meq
      SUM=0.                                                            00001330
      DO 240 I=1,4                                                      00001340
  240 SUM=SUM+TDX(I)                                                    00001350
      AK(MEQ,1)=WTX*SUM                                                 00001360
      DO 242 K=5,16                                                     00001370
      KM=K-3                                                            00001380
      AK(MEQ,KM)=TDX(K)*WTX                                             00001390
  242 CONTINUE                                                          00001400
      IF (JUZFGR .EQ. 1) then                                           TEMP****
         WRITE (6,9050) (I,TDX(I),I=1,16)                               00001420
         WRITE (6,9000)                           
      endif
      IF (JUZPR.EQ.1) then                                              00001460
         WRITE (6,9050) (I,TDX(I),I=1,16)                               00001470
         WRITE (6,9000)                                                 00001480
      endif                                                             00001490
      DO 245 I=1,16                                                     00001500
      TDXN(I)=TDX(I)                                                    00001510
  245 CONTINUE                                                          00001520
      DY(MEQ)=WTX*(OMOBS-OMFG)                                          TEMP****
      DYMKDX(MEQ)=DY(MEQ)                                               TEMP****
C ***** COMMENCE INVERSION ITERATIONS ******************************
      ITER=0                                                            00001800
  250 ITER=ITER+1                                                       00001810
      ITM=ITER-1                                                        00001820
C ***** FORWARD (PHYSICAL) MODEL CALCULATION ************************
C ***** COMPUTE N-VALUES AND PARTIAL DERIVATIVES FOR FG PROFILE *****
C ***** MAIN LOOP THROUGH ZENITH ANGLE ******************************
      DO 430 K=KB,KE                                                    00001850
      AMUO=COS(CNVRT*THENOT(K))                                         00001860
      FUM=3./16.*(1.+AMUO**2)*DPSL                                      00001870
C ***** SUB-LOOP THROUGH WAVELENGTH *********************************
      DO 400 L=1,2                                                      00001890
      IJ=0                                                              00001900
      SUM=0.                                                            00001910
      FUMT=FUM*BETA(L)                                                  00001920
      DTT(1)=ALFT(1,L)*DXN(1)+BETA(L)*DPUF(1)                           00001930
      TT(1)=DTT(1)                                                      00001940
      DLIDX(1,L)=0.
      DO 300 I=2,NCP1                                                   00001950
      SLS(I)=1.                                                         00001960
      DTT(I)=ALFT(I,L)*DXN(I)+BETA(L)*DPUF(I)                           00001970
      TT(I)=DTT(I)+TT(I-1)                                              00001980
      DLIDX(I,L)=0.                                                     00001990
  300 CONTINUE                                                          00002000
      DO 350 I=1,NCP1                                                   00002010
      DO 310 J=1,I                                                      00002020
      IJ=IJ+1                                                           00002030
  310 SLS(J)=SLANT(K,IJ)                                                00002040
      SUMS=ALFT(1,L)*SLS(1)*DXN(1)+BETA(L)*CHPP(I,K)*DPUF(1)            00002050
      IF (I.EQ.1) GO TO 330                                             00002060
      DO 320 J=2,I                                                      00002070
  320 SUMS=SUMS+SLS(J)*DTT(J)                                           00002080
  330 CON=PUF(I)*EXP(-SUMS-TT(NCP1)+TT(I))                              00002090
      IF (I.EQ.NCP1) CON=0.5*CON                                        00002100
  335 SUM=SUM+CON                                                       00002110
      DO 340 J=1,NCP1                                                   00002120
  340 DLIDX(J,L)=DLIDX(J,L)-ALFT(J,L)*CON*SLS(J)                        00002130
  350 CONTINUE                                                          00002140
      TENSTY(L)=FUMT*SUM                                                00002150
      DO 360 I=1,NCP1                                                   00002160
  360 DLIDX(I,L)=DLIDX(I,L)*FUMT/TENSTY(L)                              00002170
  400 CONTINUE                                                          00002180
C ***** END OF WAVELENGTH LOOP **************************************
      VALN(K)=100.*ALOG10(TENSTY(2)/TENSTY(1))                          00002200
      DO 410 I=1,NCP1                                                   00002210
  410 DLIDLX(I,K)=43.4294*dxn(i)*(DLIDX(I,2)-DLIDX(I,1))                
      NN=15*JC+1
      IF (NCP1.EQ.NN) GO TO 430
      IP=NCP1+1                                                         00002240
      DO 425 I=IP,NN                                                    00002260
      DO 425 J=1,I                                                      00002270
  425 IJ=IJ+1                                                           00002280
C ***** END OF ZENITH ANGLE LOOP ************************************
  430 CONTINUE                                                          00002300
      IF (JUZPR.EQ.1) then 
         WRITE (6,9100) ITER,(THENOT(K),k=kb,ke)
         write (6,9105) (VALN(K),K=KB,KE)
         WRITE (6,9000)
      endif
C ***** END OF FORWARD MODEL CALCULATION ****************************
C ***** SET UP FORCING VECTOR AND TRUNCATED DERIVATIVE MATRIX *******
      MM=0                                                              00002340
      DO 470 K=KBP,KE                                                   00002350
      MM=MM+1                                                           00002360
      DY(MM)=(VNOB(K)-VALN(K))-     (VNOB( KB)-VALN( KB))               00002370
      DYMKDX(MM)=DY(MM)                                                 00002380
      MI=0                                                              00002390
      IMAX=3*JC+1                                                       00002400
      MI=MI+1                                                           00002410
      AK(MM,MI)=0.                                                      00002420
      DO 440 I=2,IMAX                                                   00002430
      AK(MM,MI)=AK(MM,MI)+DLIDLX(I,K)-DLIDLX(I,KB)                      00002440
  440 CONTINUE                                                          00002450
      IBEG=IMAX+1                                                       00002460
      IMAX=14*JC+2                                                      00002470
      DO 450 I=IBEG,IMAX,JC                                             00002480
      MI=MI+1                                                           00002490
      AK(MM,MI)=0.                                                      00002500
      JMAX=I+JC-1                                                       00002510
      IF (JMAX.GT.NCP1) JMAX=NCP1                                       00002520
      DO 450 J=I,JMAX                                                   00002530
      AK(MM,MI)=AK(MM,MI)+DLIDLX(J,K)-DLIDLX(J,KB)                      00002540
  450 CONTINUE                                                          00002550
  470 CONTINUE                                                          00002560
      IF (JUZPR .EQ. 1)                                                 00002570
     1WRITE (6,9200) (J,J=4,16), (I,(AK(I,J),J=1,13),DY(I),I=1,MEQ)     00002580
      IF (JUZPR.EQ.1) WRITE (6,9000)                                    00002590
C ***** IF (ITER.GT.1) CALCULATE FORCING VECTOR ADJUSTMENT TERM *****
      IF (ITER.EQ.1) GO TO 510                                          00002610
      DY(MEQ)=WTX*(OMOBS-OMSOL)                                         00002620
      DO 490 I=1,MEQ                                                    00002630
      SUM=0.                                                            00002640
      DO 480 J=1,13                                                     00002650
  480 SUM=SUM-AK(I,J)*FSOL(J,ITM)                                       00002660
  490 DYMKDX(I)=DY(I)-SUM                                               00002670
C ***** EXAMINE CHANGE FROM LAST FORCING VECTOR ********************
      FEPS=0.                                                           00002690
      DO 500 I=1,MEQ                                                    00002700
  500 FEPS=FEPS+(DYMKDX(I)-FORSHD(I))**2                                00002710
      FEPS=SQRT(FEPS/FLOAT(MEQ))                                        00002720
      IF (JUZPR .EQ. 1)                                                 00002730
     1WRITE (6,9300) FEPS,(I,DYMKDX(I),I=1,MEQ)                         00002740
      IF (JUZPR.EQ.1) WRITE (6,9000)                                    00002750
  510 DO 520 I=1,MEQ                                                    00002760
  520 FORSHD(I)=DYMKDX(I)                                               00002770
C ***** MAXIMUM LIKELIHOOD INVERSION *******************************
C ***** FORM MATRIX K(TRANSPOSE) * SEPS(INVERSE) ********************
      DO 540 I=1,MEQ                                                    00002800
      DO 540 J=1,13                                                     00002810
  540 AKTSE(I,J)=AK(I,J)*SEPSIN(I+kcqn)                                 00002820
C ***** FORM MATRIX SX(INVERSE) + K(TRANSPOSE) * SEPS(INVERSE) * K
      DO 560 I=1,13                                                     00002840
      DO 560 J=I,13                                                     00002850
      SUM=0.                                                            00002860
      DO 550 K=1,MEQ                                                    00002870
  550 SUM=SUM+AK(K,I)*AKTSE(K,J)                                        00002880
      AKTSEK(I,J)=SUM+SXINV(I,J)                                        00002890
  560 AKTSEK(J,I)=AKTSEK(I,J)                                           00002900
C ***** MATRIX INVERSION
      CALL MATINV (13,AKTSEK,AKTSEK,DET)                                00002920
      DO 590 I=1,13                                                     00002930
      SUM=0.                                                            00002940
      DO 580 J=1,MEQ                                                    00002950
  580 SUM=SUM+AKTSE(J,I)*DYMKDX(J)                                      00002960
  590 FVEC(I)=SUM                                                       00002970
      IF (JUZPR .EQ. 1)                                                 00002980
     1 WRITE (6,9400) (I,FVEC(I),I=1,13)                                00002990
      IF (JUZPR.EQ.1) WRITE (6,9000)                                    00003000
C ***** CALCULATE RETRIEVAL OZONE PROFILE ***************************
      DO 610 I=1,13                                                     00003020
      SUM=0.                                                            00003030
      DO 600 J=1,13                                                     00003040
  600 SUM=SUM+AKTSEK(I,J)*FVEC(J)                                       00003050
  610 FSOL(I,ITER)=SUM                                                  00003060
      IF (JUZPR .EQ. 1)                                                 00003070
     1WRITE (6,9500) (IL(I),FSOL(I,ITER),I=1,13)                        00003080
      IF (JUZPR.EQ.1) WRITE (6,9000)                                    00003090
      DO 630 I=1,13                                                     00003100
      IP=I+3                                                            00003110
      IF (FSOL(I,ITER).LT.0.) GO TO 620                                 00003120
      TDXN(IP)=TDX(IP)*(1.+FSOL(I,ITER))                                00003130
      GO TO 630                                                         00003140
  620 TDXN(IP)=TDX(IP)*EXP(FSOL(I,ITER))                                00003150
  630 CONTINUE                                                          00003160
      DUM=TDXN(4)/TDX(4)                                                00003170
      DO 624 I=1,3                                                      00003180
  624 TDXN(I)=DUM*TDX(I)                                                00003190
      IF (JUZPR .EQ. 1)                                                 00003200
     1WRITE (6,9600) (I,TDXN(I),I=1,16)                                 00003210
      IF (JUZPR.EQ.1) WRITE (6,9000)                                    00003220
C ***** CALCULATE RESIDUALS FOR LINEAR SYSTEM ***********************
      RMSRES=0.                                                         00003240
      DO 650 I=1,MEQ                                                    00003250
      SUM=0.                                                            00003260
      DO 640 J=1,13                                                     00003270
  640 SUM=SUM+AK(I,J)*FSOL(J,ITER)                                      00003280
      RES(I)=DYMKDX(I)-SUM                                              00003290
  650 RMSRES=RMSRES+RES(I)**2                                           00003300
      RMSRES=SQRT(RMSRES/FLOAT(MEQ))                                    00003310
      IF (RMSRES.GT.9.9) RMSRES=9.9                                     00003320
      IF (JUZPR .EQ. 1)                                                 00003330
     1WRITE (6,9700) RMSRES,(I,RES(I),I=1,MEQ)                          00003340
      IF (JUZPR.EQ.1) WRITE (6,9000)                                    00003350
C ***** EXAMINE CHANGES FROM FSOL FROM LAST ITERATION ***************
      IF (ITER.EQ.1) GO TO 700                                          00003370
      DFRMS=0.                                                          00003380
      DO 660 I=1,13                                                     00003390
  660 DFRMS=DFRMS+(FSOL(I,ITER)-FSOL(I,ITM))**2                         00003400
      DFRMS=SQRT(DFRMS/13.)                                             00003410
      IF (JUZPR .EQ. 1)                                                 00003420
     1WRITE (6,9800) DFRMS                                              00003430
      IF (JUZPR.EQ.1) WRITE (6,9000)                                    00003440
C ***** CONVERGENCE TESTING BLOCK ***********************************
      JTERM=1                                                           00003470
      DO 702 I=1,13                                                     00003480
      IF (ABS(FSOL(I,ITER)-FSOL(I,ITM)).GT.0.04) JTERM=0                00003490
  702 CONTINUE                                                          00003500
      IF (DFRMS.GT.0.01) JTERM=0                                        00003510
      IF (FEPS.LE.0.15 .AND. ITER.GT.1) JTERM=1                         00003520
C ***** EXPAND SOLUTION PROFILE 13-LAYER TO UF LAYER MODEL TO GET NEW
C ********************* WSI PROFILE *********************************
  700 continue
      CALL EXPAND (PUL,TDXN,NCP1,PUFL,SXN,DXN)                          00003560
      IF (JUZPR.EQ.1) WRITE (6,9850) SXN(NCP1)                          00003570
      OMSOL=SXN(NCP1)                                                   00003580
      IF (JUZPR.EQ.1) WRITE (6,9000)                                    00003590
      if (iter.eq.1) go to 250
      IF (ITER.LT.ITMAX .AND. JTERM.EQ.0) GO TO 250                     00003610
C ***** CALCULATE ERROR STANDARD DEVIATION *************************
      DO 710 I=1,13                                                     00003630
  710 SERX(I)=100.*SQRT(AKTSEK(I,I))                                    00003640
      IF (JUZPR.EQ.1) WRITE (6,9900) (IL(I),SERX(I),I=1,13)             00003650
      IF (JUZPR.EQ.1) WRITE (6,9000)                                    00003660
C ***** PRINT FINAL RESULTS FOR THIS UMKEHR RETRIEVAL ***************
      DO 735 I=1,5
  735 TDXN(6)=TDXN(6)+TDXN(I)
      TDXN(15)=TDXN(15)+TDXN(16)
      IF (JUZDSK.EQ.0) THEN
         WRITE (6,6200) SXN(NCP1),ITER,RMSRES,DFRMS,FEPS                   3840
         WRITE (6,6300) (VNOB(K),K=KB,KE)                                  3850
         WRITE (6,6400) (RES(I),I=1,MEQM)                                  3860
         WRITE (6,6600) (TDXN(I),I=6,15)                                   3870
         WRITE (6,6700) (SERX(I),I=3,12)                                   3880
         WRITE (6,9000)                                                    00003
      ELSE
         WRITE (14,4010) OMOBS,ALFAC,(ALFBAR(L),L=1,2),SXN(NCP1),ITER,
     1   RMSRES,DFRMS,FEPS
         WRITE (14,6400) (RES(I),I=1,MEQM)
         WRITE (14,6600) (TDXN(I),I=6,15)
      ENDIF
      IF (JUZOUT.EQ.1) THEN
         OMOBS=1000.*OMOBS
         SXN(NCP1)=1000.*SXN(NCP1)
         CALL DSKOUT (OMOBS,SXN(NCP1),ID,TDXN,ITER,KB,KE,FEPS,DFRMS,
     1   RMSRES,ISN,JSX,LAM)
         OMOBS=OMOBS/1000.
         SXN(NCP1)=SXN(NCP1)/1000.
      ENDIF
C ***** COLLECT SUMS FOR FINAL RETRIEVAL STATISTICS *****************
      IF (RMSRES.GT.3.0) GO TO 730                                      00003670
      NITER=NITER+ITER
      NSOL=NSOL+1                                                       00003680
      OMOBAR=OMOBAR+OMOBS                                               00003690
      OMODEV=OMODEV+OMOBS**2                                            00003700
      OMSBAR=OMSBAR+OMSOL                                               00003710
      OMSDEV=OMSDEV+OMSOL**2                                            00003720
      RESBAR=RESBAR+RMSRES                                              00003730
      RESDEV=RESDEV+RMSRES**2                                           00003740
      DO 720 I=3,12                                                     00003750
      K=I+3                                                             00003760
      P3BAR(I)=P3BAR(I)+TDXN(K)                                         00003770
      P3DEV(I)=P3DEV(I)+TDXN(K)**2                                      00003780
      ERROR(I)=ERROR(I)+SERX(I)                                         00003790
      VARED(I)=VARED(I)+(COVF(I,I)-AKTSEK(I,I))/COVF(I,I)               00003800
  720 CONTINUE                                                          00003810
  730 CONTINUE                                                          00003820
C ***** RECYCLE TO READ NEW UMKEHR CURVE ***************************
      GO TO 220                                                         00003960
  900 CONTINUE                                                          00003970
C ***** COMPUTE FINAL STATISTICS FOR THIS STATION BATCH *************
      IF (NSOL.LE.0) GO TO 750                                          00003990
      AN=1./FLOAT(NSOL)                                                 00004000
      OMOBAR=AN*OMOBAR                                                  00004010
      OMODEV=AN*OMODEV-OMOBAR**2                                        00004020
      OMSBAR=AN*OMSBAR                                                  00004030
      OMSDEV=AN*OMSDEV-OMSBAR**2                                        00004040
      RESBAR=AN*RESBAR                                                  00004050
      RESDEV=AN*RESDEV-RESBAR**2                                        00004060
      IF (OMODEV.GT.0.) OMODEV=SQRT(OMODEV)                             00004070
      IF (OMSDEV.GT.0.) OMSDEV=SQRT(OMSDEV)                             00004080
      IF (RESDEV.GT.0.) RESDEV=SQRT(RESDEV)                             00004090
      DO 740 I=3,12                                                     00004100
      P3BAR(I)=AN*P3BAR(I)                                              00004110
      P3DEV(I)=AN*P3DEV(I)-P3BAR(I)**2                                  00004120
      IF (P3DEV(I).GT.0.) P3DEV(I)=SQRT(P3DEV(I))                       00004130
      ERROR(I)=AN*ERROR(I)                                              00004140
      VARED(I)=AN*VARED(I)                                              00004150
  740 CONTINUE                                                          00004160
      L1=10                                                             00004170
      L2=1                                                              00004180
      L3=-1                                                             00004190
      WRITE (6,6800) NSOL,OMOBAR,OMODEV,OMSBAR,OMSDEV,RESBAR,RESDEV,    00004200
     1 NITER,(LYR,LYR=L1,L2,L3),(P3BAR(I),I=3,12),(P3DEV(I),I=3,12),
     2 (ERROR(I),I=3,12),(VARED(I),I=3,12)                              00004220
      WRITE (6,9000)                                                    00004230
  750 CONTINUE                                                          00004240
      IF (ID(3).EQ.99) GO TO 190                                        TEMP****
      call time (result)
      print*,'     end   time:   ',result
      write (6,8889) result
 8889 format ('  end time: ',a11)
      STOP                                                              00004250
C ***** FORMAT STATEMENTS *******************************************
 4000 FORMAT (1H ,14X,A72)                                              TEMP****
 4002 format (1x,a72)
 4003 format (1x,a51)
 4001 FORMAT (1H ,4X,'LATITUDE=',F8.2,5X,'SFC PRESSURE=',F6.3,' ATM',
     15X,'STN HEIGHT=',F6.0,' M',5X,'STD TEMP PROFILE')
 4010 FORMAT (1H ,7HNU TOZ=,3PF5.1,3X,6HALFAS=,0P3F7.4,3X,8HSOL TOZ=,
     13PF5.1,3X,5HITER=,I1,3X,4HRES=,0PF4.2,3X,3HDF=,F5.3,3X,3HDN=,F4.2)
 4011 FORMAT (9H ********,A18,3X,4HDATE,3I3,3X,2HL=,I2,2X,2HT=,A1,2X,
     1 3HKB=,I1,2X,3HKE=,I2,2X,3HLS=,A2,2X,8HOBS TOZ=,3PF5.1,
     2 10H**********)
 5200 FORMAT (13F5.1)                                                   00004280
 5300 FORMAT (12F5.1)                                                   00004290
 5400 FORMAT (F5.1)                                                     00004300
 6000 FORMAT (1H0,28X,A72)                                              TEMP****
 6100 FORMAT (1H ,A18,3X,5HDATE=,3I3,3X,11HID DATA  L=,I2,3X,2HT=,A1,
     1 2X,3HKB=,I2,2X,3HKE=,I2,3X,3HLS=,A2,3X,12HOBSVD TOTOZ=,3PF6.1)
 6200 FORMAT (1H ,11HSOLN TOTOZ=,3PF6.1,3X,5HITER=, I2,3X,7HRMSRES=,
     1 0PF4.2, 3X,6HDFRMS= F5.3,3X,6HDNRMS=,F4.2)
 6300 FORMAT (5H NOBS  12F7.1)                                          00004370
 6500 FORMAT (23H0STANDARD PROFILE (NBS)/ (8(2X 1HL I2, E11.4)))        00004380
 6400 FORMAT (5H NRES 7X,11F7.1)                                        00004390
 6600 FORMAT (18H SOLN PROFILE (DU) 3X,3P10F7.2)                        TEMP****
 6700 FORMAT (19H EST PCT SOLN ERROR 2X 10F7.1)                         00004410
 6800 FORMAT (1H ,5X,'SOLUTION STATISTICS FOR ',I5,' PROFILES'/         00004420
     1 1H ,'TOTAL OZONE',3X,'OBSERVED=',3PF6.1,' +/- ',F6.1,5X,
     2 'SOLUTION=',F6.1,' +/- ',F6.1/ 1H ,'AVERAGE RESIDUAL=',
     3 0PF5.2,' +/- ',F5.2,10X,'TOTAL ITERATIONS=',I4/ 1H ,'LAYER',
     3 10I7/ 1H ,'AVE DU',3P10F7.2/
     4 1H ,'DEV DU',10F7.2/ 1H ,'ERROR '0P10F7.1/ 1H ,'VARED ',10F7.3)  TEMP****
 9000 FORMAT (1H  20(6H *****))                                         00004470
 9050 FORMAT (26H PRIOR INFORMATION PROFILE/1H /(6(4H LYR I3,E11.4,3X)))00004480
 9100 FORMAT (' ITERATION',I2,'  THENOT',f8.1,11f9.1)
 9105 format (16x,'NCAL',12F9.2)
 9200 FORMAT (' KERNEL AND RESIDUALS FOR THIS ITERATION'/' LAYER=' I6,1200004500
     1I8,5X 'RESIDUALS'/'  EQTN'/1H /(I5,F10.2,12F8.2,F10.1))           00004510
 9300 FORMAT (' ADJUSTED FORCING VECTOR' 5X 'RMS CHANGE FROM LAST ITERAT00004520
     1ION=' F7.2/1H /(8(' EQ' I2,F7.1,4X)))                             00004530
 9400 FORMAT (' INTERMEDIATE SOLUTION'/1H /(6(' EQ'I2,E12.3,4X)))       00004540
 9500 FORMAT (' FRACTIONAL SOLUTION CHANGE FROM PRIOR INFORMATION PROFIL00004550
     1E IN EACH LAYER'/1H /(7(' LYR' I2,F8.3,4X)))                      00004560
 9600 FORMAT (' SOLUTION PROFILE AFTER CURRENT ITERATION'/1H /(6(' LYR' 00004570
     1 I3, E11.4, 3X )))                                                00004580
 9700 FORMAT (' RESIDUALS AFTER THIS ITERATION' 10X 'RMSRES=' F6.2/1H / 00004590
     1 (8(' EQ' I2,F6.2,4X)))                                           00004600
 9800 FORMAT (' RMS CHANGE IN FRACTIONAL SOLUTION FROM LAST ITERATION=' 00004610
     1 F8.3)                                                            00004620
 9850 FORMAT (22H SOLUTION TOTAL OZONE= F7.4)                           00004630
 9900 FORMAT (' ESTIMATED ERROR OF FINAL SOLUTION IN EACH LAYER'/1H /   00004640
     1 (8(2X 1HL I2,F6.1,5X)))                                          00004650
      END                                                               00004660
      SUBROUTINE EXPAND (PUL,TDXN,NCP1,PUFL,SXN,DXN)                    00004870
C ***** EXPANDS BASIC FIRST GUESS PROFILE TO FORWARD MODEL PROFILE **
      DIMENSION PUL(16),TDXN(16),PUFL(61),SXN(61),DXN(61),XL(16)
      SUM=TDXN(1)                                                       00004900
      XL(1)=ALOG(SUM)                                                   00004910
      DO 10 I=2,16                                                      00004920
      SUM=SUM+TDXN(I)                                                   00004930
   10 XL(I)=ALOG(SUM)                                                   00004940
      CALL SPLINE (16,PUL,XL,NCP1,PUFL,SXN)                             00004950
      SXN(1)=EXP(SXN(1))                                                00004960
      DXN(1)=SXN(1)                                                     00004970
      DO 20 I=2,NCP1                                                    00004980
      SXN(I)=EXP(SXN(I))                                                00004990
   20 DXN(I)=SXN(I)-SXN(I-1)                                            00005000
      RETURN                                                            00005010
      END                                                               00005020
      SUBROUTINE SLANTS (NCP1,THENOT,SQCHP,CHPN,SQCHX,CHXN,HHH,DHH,CHPP)00005030
C ***** CALCULATES SLANT PATHS FOR FORWARD MODEL CALCULATION ********
      DIMENSION HHH(61),DHH(61),CHPP(61,12),THENOT(12)
      REAL*8 CNVRT,SN,RAYCON,THNT,DA,DB,HH(61)
      COMMON /BBBB/ SLANT(12,1891),CQMS(12,86)
      DO 5 I=1,NCP1                                                     00005070
    5 HH(I)=1.D00+HHH(I)                                                00005080
      CNVRT=DACOS(-1.D00)/180.D00                                       00005090
      DO 30 K=1,12                                                      00005100
      THNT=THENOT(K)                                                    00005110
      SN=DSIN(CNVRT*THNT)                                               00005120
      IJ=0                                                              00005130
      DO 20 I=1,NCP1                                                    00005140
      RAYCON=SN*HH(I)                                                   00005150
      AMU=RAYCON/HH(1)                                                  00005160
      AMU=SQRT(1.-AMU**2)                                               00005170
      CHPP(I,K)=OMERF(AMU*SQCHP,AMU,CHPN)                               00005180
      IJ=IJ+1                                                           00005190
      SLANT(K,IJ)=OMERF(AMU*SQCHX,AMU,CHXN)                             00005200
      IF (I.EQ.1) GO TO 20                                              00005210
      DA=DSQRT((HH(1)-RAYCON)*(HH(1)+RAYCON))                           00005220
      DO 10 J=2,I                                                       00005230
      DB=DSQRT((HH(J)-RAYCON)*(HH(J)+RAYCON))                           00005240
      IJ=IJ+1                                                           00005250
      SLANT(K,IJ)=(DA-DB)/DHH(J)                                        00005260
   10 DA=DB                                                             00005270
   20 CONTINUE                                                          00005280
   30 CONTINUE                                                          00005290
      RETURN                                                            00005300
      END                                                               00005310
      SUBROUTINE STNDRD (PUFL,DPUF,HH,DHH,CHPN,SQCHP,NCP1,JC)
C ***** READS STANDARD PRESSURE-HEIGHT PROFILE AND INTERPOLATES FOR *
C ***** FORWARD MODEL CALCULATION ***********************************
      DIMENSION PUFL(61),HH(61),DHH(61),H(81),PS(81),DPUF(61)
      PI=ACOS(-1.)                                                      00005340
      R=6371.                                                           00005350
      DO 10 I=1,81                                                      00005360
   10 H(I)=FLOAT(81-I)                                                  00005370
      READ (11,1100) (PS(I),I=1,81)                                     00005430
 1100 FORMAT (4X,7E10.3)                                                00005440
      DO 30 I=1,81                                                      00005450
   30 PS(I)=ALOG(PS(I))                                                 00005460
      DO 35 I=1,40                                                      00005470
      K=82-I                                                            00005480
      SWAP=PS(I)                                                        00005490
      PS(I)=PS(K)                                                       00005500
      PS(K)=SWAP                                                        00005510
   35 CONTINUE                                                          00005520
      CALL SPLINE (81,PS,H,NCP1,PUFL,HH)                                00005530
      HH(NCP1)=0.0                                                      00005540
      HH(1)= HH(1)/R                                                    00005550
      DO 40 J=2,NCP1                                                    00005560
      HH(J)= HH(J)/R                                                    00005570
   40 DHH(J)=HH(J-1)-HH(J)                                              00005580
      DD=R+R*HH(1)                                                      00005590
      NUM=2*(JC+1)                                                      00005600
      NUMM=NUM-1                                                        00005610
      DH=0.5*R*(HH(1)+HH(2)-HH(NUM)-HH(NUMM))                           00005620
      SCALP=DH/ALOG(DPUF(NUM)/DPUF(2))                                  00005630
      CHP=0.5*DD/SCALP                                                  00005640
      CHPN=SQRT(CHP*PI)                                                 00005650
      SQCHP=SQRT(CHP)                                                   00005660
      RETURN                                                            00005670
      END                                                               00005700
      SUBROUTINE LAYER (PUL,PUFL,PUF,DPUF,DPSL,NC,NCP1,JC)              00005710
C ***** CALCULATE PLOG  (=PUL) FOR UMKEHR BASE-LAYER MODEL **********
C ***** CALCULATE PLOG (=PUFL), P(=PUF), AND DP(=DPUF) FOR FORWARD **
C ***** CALCULATION MODEL *******************************************
      DIMENSION PUFL(61),PUF(61),DPUF(61),PUL(16)
      TWOLOG=ALOG(2.)                                                   00005730
      NC=15*JC                                                          00005780
      NCP1=NC+1                                                         00005790
      DPSL=TWOLOG/FLOAT(JC)                                             00005800
      FRAC=EXP(DPSL)                                                    00005810
      PUFL(1)=-15.*TWOLOG                                               00005820
      PUF(1)=EXP(PUFL(1))                                               00005830
      DPUF(1)=PUF(1)                                                    00005840
      DO 20 I=2,NC                                                      00005850
      IM=I-1                                                            00005860
      PUFL(I)=PUFL(IM)+DPSL                                             00005870
      PUF(I)=FRAC*PUF(IM)                                               00005880
   20 DPUF(I)=PUF(I)-PUF(IM)                                            00005890
      PUFL(NCP1)=0.                                                     00005900
      PUF(NCP1)=1.                                                      00005910
      DPUF(NCP1)=1.-PUF(NC)                                             00005920
      PUL(1)=PUFL(1)                                                    00005930
      DO 30 I=2,15                                                      00005940
   30 PUL(I)=PUL(I-1)+TWOLOG                                            00005950
      PUL(16)=0.                                                        00005960
      RETURN                                                            00005970
      END                                                               00005980
      SUBROUTINE MATINV (N,A,W,DD)                                      00005990
C ***** MATRIX INVERSION SUBROUTINE *********************************
C     N       ORDER OF MATRIX                                           00006000
C     A       LOCATION OF MATRIX                                        00006010
C     W       LOCATION OF INVERSE   THIS MAY BE THE SAME AS A IF A IS   00006020
C             NOT TO BE SAVED                                           00006030
C     DD      DETERMINANT                                               00006040
C             THE DIMENSION OF A AND V MUST MATCH THE MAIN PROGRAM      00006050
C             THE DIMENSION OF IP MUST BE AT LEAST THE ORDER OF A       00006060
      DIMENSION A(13,13),W(13,13),IP(13),IR(13)                         00006070
      DOUBLE PRECISION V(13,13),VMAX,VH,D,PVT,HOLD,DD                   00006080
      DO 27 J=1,N                                                       00006090
      IP(J)=0                                                           00006100
      DO 27 I=1,N                                                       00006110
27    V(I,J)=A(I,J)                                                     00006120
      D = 1.D0                                                          00006130
      DO 11 M=1,N                                                       00006140
      VMAX=0.                                                           00006150
      DO 1 J=1,N                                                        00006160
      IF (IP(J) .NE. 0) GO TO 1                                         00006170
3     DO 5 I=1,N                                                        00006180
      IF (IP(I) .NE. 0) GO TO 5                                         00006190
    6 VH =DABS(V(I,J))                                                  00006200
      IF(VMAX-VH)2,5,5                                                  00006210
2     VMAX=VH                                                           00006220
      K=I                                                               00006230
      L=J                                                               00006240
5     CONTINUE                                                          00006250
1     CONTINUE                                                          00006260
      IP(L)=K                                                           00006270
      IR(M)=L                                                           00006280
4     D=D*V(K,L)                                                        00006290
      PVT=V(K,L)                                                        00006300
      V(K,L) = 1.D0                                                     00006310
      DO 15 J=1,N                                                       00006320
      HOLD=V(K,J)                                                       00006330
      V(K,J)=V(L,J)                                                     00006340
15    V(L,J)=HOLD/PVT                                                   00006350
      DO 11 I=1,N                                                       00006360
      IF(I.EQ.L) GO TO 11                                               00006370
      HOLD=V(I,L)                                                       00006380
      V(I,L)=0.                                                         00006390
      DO 12 J=1,N                                                       00006400
12    V(I,J)=V(I,J)-V(L,J)*HOLD                                         00006410
11    CONTINUE                                                          00006420
      DO 9 J=1,N                                                        00006430
      M=N-J+1                                                           00006440
      L=IR(M)                                                           00006450
      K=IP(L)                                                           00006460
      IF(K.EQ.L) GO TO 9                                                00006470
      D=-D                                                              00006480
      DO 8 I=1,N                                                        00006490
      HOLD=V(I,L)                                                       00006500
      V(I,L)=V(I,K)                                                     00006510
      V(I,K)=HOLD                                                       00006520
8     CONTINUE                                                          00006530
9     CONTINUE                                                          00006540
      DD = D                                                            00006550
      DO 40 I = 1, N                                                    00006560
      DO 40 J = 1, N                                                    00006570
   40 W(I,J) = V(I,J)                                                   00006580
      RETURN                                                            00006590
      END                                                               00006600
      FUNCTION OMERF (X, Y, SQ)                                         00006610
C ***** CALCULATES CHAPMAN FUNCTION FOR OZONE ABSORPTION AND ********
C ***** RAYLEIGH SCATTERING ATTENUATION PATH ABOVE TOP OF LAYERS ****
C ***** OF FORWARD MODEL ********************************************
      DIMENSION A(5)                                                    00006620
      DATA P/ .3275911/, A/ 1.061405429, -1.453152027,                  00006630
     1 1.421413741, -0.284496736, 0.254829592/                          00006640
      IF (Y .GE. 0.2) GO TO 20                                          00006650
      T = 1./(1. + P*X)                                                 00006660
      SUM = T*A(1)                                                      00006670
      DO 10 I = 2, 5                                                    00006680
   10 SUM = T*(A(I) + SUM)                                              00006690
      OMERF = SUM*SQ                                                    00006700
      RETURN                                                            00006710
   20 T = 0.5/(X**2)                                                    00006720
      OMERF = (1. - T*(1. - 3.*T*(1. - 5.*T)))/Y                        00006730
      RETURN                                                            00006740
      END                                                               00006750
      SUBROUTINE SPLINE (N,X,Y,M,A,B)                                   00006760
C ***** PERFORMS SPLINE INTERPOLATION USING ROUTINE SPLSET **********
      DIMENSION C(4,81),X(n),Y(n),A(m),B(m)
      CALL SPLSET (X,Y,N,C)                                             00006780
      NM=N-1                                                            00006790
      J=1                                                               00006800
      XD=A(1)                                                           00006810
      DO 20 I=1,NM                                                      00006820
      IP=I+1                                                            00006830
      IF (XD.GT.X(IP)) GO TO 20                                         00006840
   10 DA=X(IP)-XD                                                       00006850
      DB=XD-X(I)                                                        00006860
      B(J)=DA*(C(1,I)*DA**2+C(3,I)) + DB*(C(2,I)*DB**2+C(4,I))          00006870
      J=J+1                                                             00006880
      IF (J.GT.M) GO TO 30                                              00006890
      XD=A(J)                                                           00006900
      IF (XD.GT.X(I) .AND. XD.LE.X(IP)) GO TO 10                        00006910
      IF (XD.LE.X(1)) GO TO 10                                          00006920
   20 CONTINUE                                                          00006930
   30 CONTINUE                                                          00006940
      RETURN                                                            00006950
      END                                                               00006960
      SUBROUTINE SPLSET(X,Y,M,C)                                        00006970
C ***** CALCULATES TABLE OF COEFFICIENTS FOR SPLINE INTERPOLATION ***
C***** X = INDEPENDENT VARIABLE                                         00006980
C***** Y = DEPENDENT VARIABLE                                           00006990
C***** M = NUMBER OF DATA POINTS IN THE X AND Y ARRAYS                  00007000
C***** C = COEFFICENTS OF THE CUBIC THAT IS FIT BETWEEN ADJACENT DATA PO00007010
C***** THE FOLLOWING DIMENSIONS MUST BE .GE. M                          00007020
      DIMENSION D(81), P(81), E(81), A(81,3), B(81), Z(81)
      DIMENSION X(m),Y(m),C(4,m)
      MM=M-1                                                            00007050
      DO 2 K=1,MM                                                       00007060
      D(K)=X(K+1)-X(K)                                                  00007070
      P(K)=D(K)/6.                                                      00007080
  2   E(K)=(Y(K+1)-Y(K))/D(K)                                           00007090
      DO 3 K=2,MM                                                       00007100
  3   B(K)=E(K)-E(K-1)                                                  00007110
      A(1,2)=-1.-D(1)/D(2)                                              00007120
      A(1,3)=D(1)/D(2)                                                  00007130
      A(2,3)=P(2)-P(1)*A(1,3)                                           00007140
      A(2,2)=2.*(P(1)+P(2))-P(1)*A(1,2)                                 00007150
      A(2,3)=A(2,3)/A(2,2)                                              00007160
      B(2)=B(2)/A(2,2)                                                  00007170
      DO 4  K=3,MM                                                      00007180
      A(K,2)=2.*(P(K-1)+P(K))-P(K-1)*A(K-1,3)                           00007190
      B(K)=B(K)-P(K-1)*B(K-1)                                           00007200
      A(K,3)=P(K)/A(K,2)                                                00007210
  4   B(K)=B(K)/A(K,2)                                                  00007220
      Q=D(M-2)/D(M-1)                                                   00007230
      A(M,1)=1.+Q+A(M-2,3)                                              00007240
      A(M,2)=-Q-A(M,1)*A(M-1,3)                                         00007250
      B(M)=B(M-2)-A(M,1)*B(M-1)                                         00007260
      Z(M)=B(M)/A(M,2)                                                  00007270
      MN=M-2                                                            00007280
      DO 6 I=1,MN                                                       00007290
      K=M-I                                                             00007300
  6   Z(K)=B(K)-A(K,3)*Z(K+1)                                           00007310
      Z(1)=-A(1,2)*Z(2)-A(1,3)*Z(3)                                     00007320
      DO 7 K=1,MM                                                       00007330
      Q=1./(6.*D(K))                                                    00007340
      C(1,K)=Z(K)*Q                                                     00007350
      C(2,K)=Z(K+1)*Q                                                   00007360
      C(3,K)=Y(K)/D(K)-Z(K)*P(K)                                        00007370
  7   C(4,K)=Y(K+1)/D(K)-Z(K+1)*P(K)                                    00007380
      RETURN                                                            00007390
      END                                                               00007400
      SUBROUTINE SASCO3 (ID,ILAT,PNOT,OMOBS,TDX,juzsea)                 TEMP****
C **** SUBROUTINE TO CREATE SASC STANDARD PROFILES ******************
C **** INPUT INCLUDES LATITUDE BAND NUMBER 1,...,6                      00007430
C ****                DAY AND MONTH TO GET JULIAN DAY                   00007440
C ****                TOTAL OZONE IN M ATM-CM                           00007450
C ****                                                                  00007460
      DIMENSION C(6,13,3),TDX(16),SX(16),MONTH(12),ID(7),R3(13)         00007470
      integer*2 juzsea
      DATA MONTH/0,31,59,90,120,151,181,212,243,273,304,334/            00007480
      DATA JUMP/0/                                                      00007490
      DATA C0/1.72142E-02/                                              00007500
      CNVRT=2.584E-03
      IF (JUMP.EQ.1) GO TO 50                                           00007510
      JUMP=1                                                            00007520
      JSMUTH=1                                                          TEMP****
      DO 20 L=1,6                                                       00007530
      DO 20 K=1,3                                                       00007540
      READ (9,9000) (C(L,I,K),I=1,6)                                    TEMP****
      READ (9,9000) (C(L,I,K),I=7,13)                                   00007560
   20 CONTINUE                                                          00007570
      IF (juzsea.EQ.1) GO TO 50                                           00007580
      DO 30 L=1,6                                                       00007590
      DO 30 I=7,13                                                      00007600
   30 C(L,I,2)=0.0*C(L,I,2)                                             00007610
   50 CONTINUE                                                          00007620
      AJULDA=FLOAT(ID(3)+MONTH(ID(4)))                                  00007630
      OM=1000.*OMOBS                                                    00007640
      DOM=2.*(1.-PNOT)*C(ILAT,1,1)                                      TEMP****
      OM=OM+DOM                                                         TEMP****
      DX=OM-300.                                                        00007670
      SX(1)=OM                                                          00007680
      DO 60 I=1,5                                                       00007690
      TDX(I)=C(ILAT,I,1)+DX*(C(ILAT,I,2)+DX*C(ILAT,I,3))                00007700
      IF (I.EQ.4 .AND. ILAT.EQ.1 .AND. OM.LT.300.) THEN                 TEMP****
         TDX(4)=TDX(4)-.003*(DX**2)                                     00007720
      ENDIF                                                             00007730
      IF (I.GT.1) SX(I)=SX(I-1)-TDX(I-1)                                00007740
   60 CONTINUE                                                          00007750
      DO 70 I=7,13                                                      00007760
   70 TDX(I)= C(ILAT,I,1)+C(ILAT,I,2)*COS(C0*(AJULDA-C(ILAT,I,3)))      00007770
      SX(13)=TDX(13)                                                    00007780
      DO 80 I=12,7,-1                                                   00007790
   80 SX(I)=SX(I+1)+TDX(I)                                              00007800
      DO 82 I=4,8                                                       00007810
      IF (I.NE.6) SX(I)=ALOG(SX(I))                                     00007820
   82 CONTINUE                                                          00007830
        SX(6)=(4.*(SX(5)+SX(7))-SX(4)-SX(8))/6.                         00007840
      DO 84 I=4,8                                                       00007850
   84 SX(I)=EXP(SX(I))                                                  00007860
      TDX(5)=SX(5)-SX(6)                                                00007870
      TDX(6)=SX(6)-SX(7)                                                00007880
      DO 86 I=1,12                                                      00007890
   86 R3(I)=TDX(I)*CNVRT*(2**(I-1))                                     00007900
      DUM=0.5*(R3(8)+R3(6))                                             00007910
      IF (DUM.GT.R3(7) .AND. JSMUTH.EQ.1) THEN                          00007920
         DR=0.4*(DUM-R3(7))                                             00007930
         R3(6)=R3(6)-DR                                                 00007940
         R3(7)=R3(7)+2.*DR                                              00007950
         TDX(6)=R3(6)/(CNVRT*32)                                        00007960
         TDX(7)=R3(7)/(CNVRT*64)                                        00007970
      ENDIF                                                             00007980
      RR=SX(13)/SX(12)                                                  00007990
      DO 90 I=14,16                                                     00008000
      IM=I-1                                                            00008010
      SX(I)=RR*SX(IM)                                                   00008020
      TDX(IM)=SX(IM)-SX(I)                                              00008030
   90 CONTINUE                                                          00008040
      TDX(16)=SX(16)                                                    00008050
      DO 100 I=1,16                                                     00008060
  100 TDX(I)=0.001*TDX(I)                                               00008070
      DO 110 I=1,8                                                      00008080
      K=17-I                                                            00008090
      SWAP=TDX(I)                                                       00008100
      TDX(I)=TDX(K)                                                     00008110
      TDX(K)=SWAP                                                       00008120
  110 CONTINUE                                                          00008130
      TDX(16)=TDX(16)-0.001*DOM                                         TEMP****
 9000 FORMAT (7E10.3)                                                   00008140
      RETURN                                                            00008150
      END                                                               00008160
      SUBROUTINE DSKOUT (OMOBS,OMSOL,ID,TDXN,ITER,KB,KE,FEPS,DFRMS,
     1 RMSRES,ISN,JSX,LAM)
C ***** SETS UP AND WRITES DISK OR TAPE OUTPUT FILE *****************
      DIMENSION ID(7),TDXN(16),IOUT(19)
      character*1 jsx
      NK=KE-KB+1
      IOUT(1)=INT(OMOBS+0.5)
      IOUT(2)=INT(10.*OMSOL+0.5)
      DO 20 I=3,12
      ISTAR=I+3
      SCALE=100000.
      IF (I.GT.5) SCALE=10000.
   20 IOUT(I)=INT(SCALE*TDXN(ISTAR)+0.5)
      IOUT(13)=ITER
c      IOUT(14)=JSX
      IOUT(15)=KB
      IOUT(16)=NK
      IOUT(17)=INT(1000.*DFRMS+0.5)
      IOUT(18)=INT(100.*FEPS+0.5)
      IOUT(19)=INT(100.*RMSRES+0.5)
      WRITE (4,4000) (ID(I),I=3,6),LAM,(IOUT(I),I=1,13),jsx,(iout(i),
     1 i=15,19),ISN
 4000 FORMAT (3I2,A1,I1,I4,I5,2I4,I5,3I4,3I5,I4,I2,A1,I1,I2,2I3,I4,I3)
      RETURN
      END